function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import includes from 'lodash/includes';
export default class CheckboxGroup extends React.Component {
  constructor(props) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
  }

  handleChange(value, checked) {
    const values = this.props.children.filter(option => {
      if (option.props.value === value) {
        return checked;
      }

      return includes(this.props.values, option.props.value);
    }).map(option => {
      return option.props.value;
    });
    this.props.onChange(values);
  }

  render() {
    const children = React.Children.map(this.props.children, Checkbox => /*#__PURE__*/React.cloneElement(Checkbox, {
      key: Checkbox.props.name,
      my: 2,
      checked: includes(this.props.values, Checkbox.props.value),
      disabled: this.props.disabled,
      onChange: event => this.handleChange(Checkbox.props.value, event.target.checked)
    }));
    return this.props.unwrap ? children : /*#__PURE__*/React.createElement("div", null, children);
  }

}

_defineProperty(CheckboxGroup, "propTypes", {
  values: PropTypes.arrayOf(PropTypes.string).isRequired,
  onChange: PropTypes.func.isRequired,
  children: PropTypes.node.isRequired,
  disabled: PropTypes.bool,
  unwrap: PropTypes.bool
});

_defineProperty(CheckboxGroup, "defaultProps", {
  unwrap: false
});